﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace N4
{
    class PodelaSkupa
    {
        static int podeli(int[] brojevi, bool[] odabran, int k)
        {
            if (k == brojevi.Length)
            {
                int s1=0, s2=0;
                for (int i = 0; i < brojevi.Length; i++)
                    if (odabran[i])
                        s1 += brojevi[i];
                    else
                        s2 += brojevi[i];
                return Math.Abs(s1 - s2);
            }

            bool[] resenje1 = new bool[brojevi.Length];
            odabran[k] = true;
            int r1 = podeli(brojevi, odabran, k + 1);
            //pamtimo ne samo minimalnu razliku resenja 1, vec i koji su bili odabrani elementi pritom
            for (int i = 0; i < odabran.Length; i++)
                resenje1[i] = odabran[i];
            //sad posmatramo da li se bolje resenje dobija ako je k-ti element van prvog skupa
            odabran[k] = false;
            int r2 = podeli(brojevi, odabran, k + 1);
            //nema potrebe da pamtimo niz odabran, jer je ovo poslednje sto se desilo
            if (r1 < r2)
            {
                //vracamo niz odabranih na resenje dobijeno zadrzavanjem k-tog elementa u prvom skupu
                for (int i = 0; i < resenje1.Length; i++)
                    odabran[i] = resenje1[i];
                return r1;
            }
            else
            {
                return r2;
            }
        }

        static void Main(string[] args)
        {
            int[] brojevi = new int[] {1,2,3,4,46,34,65,3,2,55,3};
            bool[] odabran=new bool[brojevi.Length];
            int razlika = podeli(brojevi, odabran, 0);
            Console.WriteLine("Minimalna razlika je " + razlika+" i dobija se za podelu: ");
            for (int i = 0; i < brojevi.Length; i++)
                if (odabran[i])
                    Console.Write(" " + brojevi[i]);
            Console.WriteLine();
            for (int i = 0; i < brojevi.Length; i++)
                if (!odabran[i])
                    Console.Write(" " + brojevi[i]);
            Console.WriteLine();
        }
    }
}
